<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Mid-term exam</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DevCamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">LinhLT</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="album.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Album CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="photo.crud.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Photo CRUD</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>J405</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Quản trị Thư viện ảnh</h2>
        <div class="jumbotron container">
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="code">Mã Photo</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-code" name="code" placeholder="Photo code"
            class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="name">Tên Photo</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-name" name="name" placeholder="Photo name" class="form-control">
          </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="link">Link Photo</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-link" name="link" placeholder="URL" class="form-control">
            </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="title">Mô tả</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-title" name="title" placeholder="Title" class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="createDate">Ngày Tạo</label>
          </div>
          <div class="col-sm-9">
            <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
          </div>
          </div>
          <div class="row form group">
            <div class = "col-sm-3">
              <label for = "album">Tên Album</label>
            </div>
            <div class = "col-sm-9">
              <select id="select-album" name="album" class = "form-control">
              </select>
            </div>
          </div>
          <div class = "row form-group">
          </div>
          <div class="row pull-right">
          <div class="col-sm-3">
          </div>
          <div class="col-sm-9">
            <div class ="row">
              <div class="col-sm-3">
                <button id="btn-update-photo" class="btn btn-info"><i class="fas fa-edit"></i>&nbsp;Update photo</button>
              </div>
              <div class="col-sm-3">
                <button id="btn-delete-photo" class="btn btn-danger"><i class="fas fa-trash"></i>&nbsp;Delete photo</button>
              </div>
              <div class="col-sm-3">
                <button id="btn-create-photo" class="btn btn-success"><i class="fa fa-plus"></i>&nbsp;Add New photo</button>
              </div>
              <div class = "col-sm-3">
                <button id="btn-cancel" class="btn btn-secondary">Cancel</button>
              </div>
            </div>
          </div>
          
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="photo-table">
          <thead>
            <tr>
              <th>Id</th>
              <th>Mã Ảnh</th>
              <th>Tên Ảnh</th>
              <th>Link Ảnh</th>
              <th>Mô tả</th>
              <th>Ngày tạo</th>
            </tr>
        </table>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Xác nhận xóa photo</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa photo này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete">Xác nhận</button>
            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id photo đang đc update or delete. Mặc định = 0;
var gPhotoId = 0;
const gBASE_URL = "http://localhost:8080/photo";
const gCONTENT_TYPE = "application/json;charset=UTF-8";
var gAlbumSelectElement = $("#select-album");
var gPhotoArr = [];
$(document).ready(function(){
  getAllAlbums();
	var table = $("#photo-table").DataTable({
		"columns": [
			{"data":"id"},
			{"data":"code"},
			{"data":"name"},
      {"data":"url"},
			{"data":"title"},
			{"data":"created"},
		]
	})
	$.ajax({
		url: gBASE_URL + "/all",
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
      gPhotoArr = res;
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.responseText);
		}
	})
		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#photo-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update photo: add event to save data button
	$("#btn-update-photo").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new photo
	$("#btn-create-photo").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete photo selected
	$("#btn-delete-photo").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Cancel
	$("#btn-cancel").on("click",function(){
		onCancelBtnClick();
	});
  //gán sự kiện cho nút xác nhận xóa data trên modal
  $("#btn-confirm-delete").on("click",function(){
    onBtnConfirmDeletePhotoClick();
  });
  
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gPhotoId = $(paramRow).find("td:eq(0)").html();
		console.log("Photo id of selected row: " + gPhotoId);
		//lấy thông tin photo của row được click và hiển thị lên form
		var vPhoto = callApiGetPhotoById(gPhotoId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo photo obj
		var vPhotoObj = {
			code: "",
			name: "",
      url:"",
			title:"",
		}
		// B1: Thu thập dữ liệu
		getUpdatePhotoData(vPhotoObj);
		// B2: Validate update
		var vIsPhotoValid = validatePhotoData(vPhotoObj);
    	if (vIsPhotoValid){
			// B3: update photo
			$.ajax({
				url: gBASE_URL +"/update/"+ gPhotoId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vPhotoObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdatePhotoSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm photo
	function onCreateButtonClick(){
		//khai báo photo obj
		var vPhotoObj = {
			code: "",
			name: "",
      url:"",
			title:"",
      album: -1
		}
		// B1: Thu thập dữ liệu
		getCreatePhotoData(vPhotoObj);
		// B2: Validate data
		var vIsPhotoValid = validatePhotoData(vPhotoObj);
    	if (vIsPhotoValid){
			// B3: create photo
			$.ajax({
				url: gBASE_URL + "/create/" + vPhotoObj.album,
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vPhotoObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreatePhotoSuccess();
				},
				error: function(err){
					alert(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa photo được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    $("#delete-modal").modal("show");
	}
  //hàm xử lý sự kiện xác nhận xóa photo
  function onBtnConfirmDeletePhotoClick(){
    "use strict";
    //gọi API xóa photo
    ajaxDeletePhoto(gPhotoId);
  }
  
	function onCancelBtnClick(){
    $("#input-code").val("");
		$("#input-name").val("");
    $("#input-link").val("");  
		$("#input-title").val(""); 
		$("#input-createDate").val(""); 
	}
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
	//hàm load lại datatable
  function loadDataToTable(){
    $.ajax({
      url: gBASE_URL + "/all",
      type: "GET",
      dataType: "json",
      success: function(res){
        console.log(res);
        table.clear();
        table.rows.add(res);
        table.draw();
      },
      error: function(err){
        console.log(err.responseText);
      }
    })
  }
  //load data to album select
  function getAllAlbums(){
    $.ajax({
      url: "http://localhost:8080/album/all",
      method: "GET",
      success: function(pObjRes) {
        console.log(pObjRes);
        loadDataToAlbumSelect(pObjRes);
      },
      error: function(paramErr) {
        console.log(paramErr.responseText);
      }
    });
    //load data to album select
    function loadDataToAlbumSelect(pAlbumList) {
      for (let i = 0; i < pAlbumList.length; i++) {
        var bAlbumOption = $("<option/>");
        bAlbumOption.prop("value", pAlbumList[i].id);
        bAlbumOption.prop("text", pAlbumList[i].name);
        gAlbumSelectElement.append(bAlbumOption);
      };
    }
  }
  //hàm gọi API lấy thông tin photo của dòng được chọn
	function callApiGetPhotoById(paramId){
		$.ajax({
			url: gBASE_URL +"/detail/"+ paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayPhotoData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin photo của dòng được click
	function displayPhotoData(paramPhoto){
		$("#input-code").val(paramPhoto.code);
		$("#input-name").val(paramPhoto.name);
    $("#input-link").val(paramPhoto.url);  
		$("#input-title").val(paramPhoto.title); 
		$("#input-createDate").val(paramPhoto.created); 
	}
	// hàm thu thập dữ liệu để update photo
	function getUpdatePhotoData(paramPhotoObj) {
    paramPhotoObj.id = gPhotoId;
		paramPhotoObj.code =$("#input-code").val().trim();
		paramPhotoObj.name = $("#input-name").val().trim(); 
    paramPhotoObj.url = $("#input-link").val().trim(); 
		paramPhotoObj.title = $("#input-title").val().trim(); 
	}
  // hàm thu thập dữ liệu để create photo
	function getCreatePhotoData(paramPhotoObj) {
		paramPhotoObj.code =$("#input-code").val().trim();
		paramPhotoObj.name = $("#input-name").val().trim(); 
    paramPhotoObj.url = $("#input-link").val().trim(); 
		paramPhotoObj.title = $("#input-title").val().trim();
    paramPhotoObj.album = $("#select-album").val(); 
	}

	// hàm validate data
	function validatePhotoData(paramPhotoObj) {
		if (paramPhotoObj.code === "") {
      alert("Cần nhập mã photo");
      return false;
		}
    
		if (paramPhotoObj.name === "") {
      alert("Cần nhập tên photo");
      return false;
		}

    if (paramPhotoObj.url === "") {
      alert("Cần nhập link photo");
      return false;
		}

		if (paramPhotoObj.title === "") {
      alert("Cần nhập mô tả photo");
      return false;
		}

    //for (let i=0; i< gPhotoArr.length; i++){
      //if (gPhotoArr[i].code = paramPhotoObj.code && gPhotoArr[i].id != gPhotoId){
        //alert("Mã photo đã tồn tại");
        //return false;
      //}
    //}

		return true;
	}
	
	//hiển thị cập nhật photo thành công
	function handleUpdatePhotoSuccess(){
		alert("Sửa photo có id: " + gPhotoId + " thành công!");
    loadDataToTable();
	};
	//hiển thị thêm photo thành công
	function handleCreatePhotoSuccess(){
		alert("Thêm photo thành công!");
    loadDataToTable();
	};
  //API xóa photo
  function ajaxDeletePhoto(paramId){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
    $.ajax({
      url: gBASE_URL +"/delete/"+ paramId,
      type: "DELETE",
      success: function(paramRes) {
        handleDeletePhotoSuccess();
      },
      error: function(paramErr) {
        alert("Xóa photo không thành công");
      }
    });
  };
  
	//hiển thị xóa photo thành công
	function handleDeletePhotoSuccess(){
		alert("Xóa photo có id: " + gPhotoId + " thành công!");
    loadDataToTable();
    //ẩn modal
    $("#delete-modal").modal("hide");
	};
})
</script>
</body>
</html>
